﻿using CYQ.Data.Cache;
using CYQ.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using StackExchange.Redis;

namespace CacheManage_Demo
{
    public static class StackExchange
    {
        public static ConnectionMultiplexer redis = null;
        public static IDatabase db;
        public static void Start()
        {

            redis = ConnectionMultiplexer.Connect("127.0.0.1:6379");
            //// 清空所有数据
            //var endpoints = redis.GetEndPoints();
            //foreach (var endpoint in endpoints)
            //{
            //    var server = redis.GetServer(endpoint);
            //    server.FlushAllDatabases();
            //}
            // 连接到 Redis 服务器
            db = StackExchange.redis.GetDatabase();

            int readCount = 100000, userDBCount = 1;
            ThreadPool.SetMinThreads(128, 128);
            //ThreadPool.SetMaxThreads(1000, 1000);

            new ThreadRun2(1, readCount, userDBCount).Start();
            new ThreadRun2(2, readCount, userDBCount).Start();
            new ThreadRun2(4, readCount, userDBCount).Start();
            new ThreadRun2(8, readCount, userDBCount).Start();
            new ThreadRun2(16, readCount, userDBCount).Start();
            new ThreadRun2(32, readCount, userDBCount).Start();
            new ThreadRun2(48, readCount, userDBCount).Start();
            for (int j = 0; j < 1; j++)
            {
                new ThreadRun2(64, readCount, userDBCount).Start();
            }
            new ThreadRun2(78, readCount, userDBCount).Start();
            new ThreadRun2(90, readCount, userDBCount).Start();
            new ThreadRun2(100, readCount, userDBCount).Start();
            for (int i = 0; i < 1; i++)
            {
                new ThreadRun2(128, readCount, userDBCount).Start();
            }


            //new ThreadRun2(1, readCount, userDBCount).Start();
            //new ThreadRun2(4, readCount, userDBCount).Start();
            //new ThreadRun2(8, readCount, userDBCount).Start();
            ////new ThreadRun2(10, readCount, userDBCount).Start();
            ////new ThreadRun2(20, readCount, userDBCount).Start();
            //new ThreadRun2(50, readCount, userDBCount).Start();
            //new ThreadRun2(100, readCount, userDBCount).Start();
            ////new ThreadRun2(200, readCount, userDBCount).Start();
            ////new ThreadRun2(500, readCount, userDBCount).Start();
            ////new ThreadRun2(1000, readCount, userDBCount).Start();
            ////new ThreadRun(2000, readCount, userDBCount).Start();

            ////new ThreadRun(5000, readCount, userDBCount).Start();
            ////new ThreadRun(2000, readCount, userDBCount).Start();
            ////new ThreadRun(2000, readCount, userDBCount).Start();
            ////new ThreadRun2(500, readCount, userDBCount).Start();
            ////new ThreadRun2(200, readCount, userDBCount).Start();
            ////new ThreadRun2(100, readCount, userDBCount).Start();
            //new ThreadRun2(50, readCount, userDBCount).Start();
            ////new ThreadRun2(20, readCount, userDBCount).Start();
            ////new ThreadRun2(10, readCount, userDBCount).Start();
            //new ThreadRun2(8, readCount, userDBCount).Start();
            //new ThreadRun2(4, readCount, userDBCount).Start();
            //new ThreadRun2(1, readCount, userDBCount).Start();

            Console.WriteLine("End");
            //Console.WriteLine(CacheManage.RedisInstance.WorkInfo);
            Console.Read();
        }
    }
    public class ThreadRun2
    {



        int threadCount, setOrReadCount, useDBCount;

        public ThreadRun2(int threadCount, int setOrReadCount, int useDBCount)
        {

            //// 清空所有数据
            //var endpoints = StackExchange.redis.GetEndPoints();
            //foreach (var endpoint in endpoints)
            //{
            //    var server = StackExchange.redis.GetServer(endpoint);
            //    server.FlushAllDatabases();
            //}

            //db = redis.
            this.threadCount = threadCount;
            this.setOrReadCount = setOrReadCount;
            this.useDBCount = useDBCount;
        }
        System.Diagnostics.Stopwatch gloWatch = new System.Diagnostics.Stopwatch();
        int runEndCount = 0;
        bool isEnd = false;
        public void Start()
        {
            gloWatch.Start();
            for (int i = 0; i < threadCount; i++)
            {
                ThreadPool.QueueUserWorkItem(new WaitCallback(ThreadStart), setOrReadCount / threadCount);
            }

            while (!isEnd)
            {
                Thread.Sleep(10);
            }

        }

        public void ThreadStart(object readCount)
        {
            string rndKey = Guid.NewGuid().ToString().Substring(0, 5);
            int max = (int)readCount;
            var db = StackExchange.db;
            for (int i = 0; i < max; i++)
            {
                string key = rndKey + "key" + i;

                //cache.Set(key, Guid.NewGuid().ToString());
                // 获取 Redis 数据库
                if (db.StringSet(key, Guid.NewGuid().ToString(), TimeSpan.FromHours(DateTime.Now.Second + 1)))
                {

                }
                else
                {
                    Console.WriteLine("Set 失败 key :" + key);
                }

            }

            Interlocked.Increment(ref runEndCount);
            if (runEndCount >= threadCount && !isEnd)
            {
                isEnd = true;
                gloWatch.Stop();
                //Ng  2000ms
                //x     1000ms
                long t = gloWatch.ElapsedMilliseconds;
                float count = (long)setOrReadCount * 1000 * 10000 / gloWatch.ElapsedTicks;
                Console.WriteLine(string.Format("ThreadCount : {0} , Run : {1}  Time {2} ms ,{3} requests per second. ", threadCount, setOrReadCount, t.ToString(), count));
                //CacheManage.RedisInstance.Clear();//操作对象
                DistributedCache.Redis.Clear();
            }
        }
    }
}
